<?
require_once('sonos.class.php');
require_once('sonos.ips.defines.php');
@include_once('sonos.ips.config.php');
if(!function_exists('Debug')){function Debug($data){if($_IPS['SENDER']=='Execute')echo $data.PHP_EOL;else IPS_LogMessage('SONOS_LOG:',$data);}}
class IPSSonosPlayer extends SonosUpnpDevice {
	private $INSTANCE_ID=0;
	
	public function __construct($data){
		$id=0;
		if(is_numeric($data)){
			$id=$data;
			$data=GetValue(IPS_GetObjectIdByIdent(SONOS_ident_host,$data));
		}
		parent::__construct($data);
		$this->INSTANCE_ID=$id;
//Debug("ObjectId: $id");
	}
	
	public function getZonePlayerList(){
		
		if(!$xml=$this->deviceCmdRaw('/status/topology')){
			return false;
		}	
		$topology = simplexml_load_string($xml);
		$myself = null;
		$coordinators = [];
		// Loop players, build map of coordinators and find myself
		foreach ($topology->ZonePlayers->ZonePlayer as $player)	{
			$player_data = $player->attributes();
			$name=utf8_decode((string)$player);
			$group=explode('RINCON_',(string)$player_data->group)[1];

			$ip = parse_url((string)$player_data->location)['host'];
			$port = parse_url((string)$player_data->location)['port'];
			if($ip==$this->_IP){
				$info=$this->GetZoneAttributes();
			} else {
				$p=new self($ip,$port);
				$info=$p->GetZoneAttributes();
				$p=null;
			}
			$player = array(
				'host'=>"$ip:$port",
				'name'=>$name,
				'icon'=>$info['CurrentIcon'],
				'master'=>((string)$player_data->coordinator == 'true'),
				'ident'=>explode('RINCON_',(string)$player_data->uuid)[1]
			);
			$coordinators[$group][] = $player;
		}
		function cmp($a, $b) {
			if ($a['master'] == $b['master']) {
				if($a['name'] == $b['name']) 
					return 0;
				else 
					return ($a['name'] > $b['name']) ? 1 : -1;;
			}
			return ($a['master'] === TRUE) ? -1 : 1;
		}
		foreach ($coordinators as $key=>$coordinator){
			usort($coordinators[$key], "cmp");
		}
		return $coordinators;
	}
	
	public function UpdateStatus(){
		$this->SetState(-1);
		$this->SetVolume(-1);
//		$data=$this->GetPositionInfo();
//		$str="{$data['Title']} ({$data['TitleArtist']})";
//		SetValue(IPS_GetObjectIDByIdent(SONOS_ident_csong,$this->ID), $str);
	}
	public function UpdateOptions(){
		$this->SetMute(-1);
		$this->SetCrossfadeMode(-1);
		$this->SetLEDState(-1);
		$this->SetPlayMode(-1);
	}
	public function SetState($value){
		$id=@IPS_GetObjectIDByIdent(SONOS_ident_state,$this->INSTANCE_ID);
	
		if($value<0){
			$data=$this->GetTransportInfo();
			switch($data){
				case 'STOP': $v=SONOS_state_stop; break;
				case 'PAUSED_PLAYBACK': $v=SONOS_state_pause; break;
				case 'PLAY': $v=SONOS_state_play; break;
				default: $v=SONOS_state_play;
			}
		}else{
			$v=$value;
			switch($value){
				case SONOS_state_stop: $ok=$this->Stop(); break;
				case SONOS_state_play: $ok=$this->Play(); break;
				case SONOS_state_pause:$ok=$this->Pause(); break;
				case SONOS_state_first:
				case SONOS_state_prev: $v=SONOS_state_play;$ok=$this->Previous(); break;
				case SONOS_state_next:
				case SONOS_state_last: $v=SONOS_state_play;$ok=$this->Next(); break;
				default: $ok=false;
			}
			if(!$ok){
				$this->SetState(-1);
				return false;
			}
		}		
		SetValue($id,$v);
		return true;
	}
	public function SetVolume($value){
		$id=@IPS_GetObjectIDByIdent(SONOS_ident_vol,$this->INSTANCE_ID);
		if($value<0)$value=$this->GetVolume();
		else $ok=parent::SetVolume($value);
		SetValue($id,$value);
	}
	public function SetGroupVolume($value){
		if($value<0)$value=$this->GetGroupVolume();
		else $ok=parent::SetGroupVolume($value);
		SetValue(VAR_ZoneVolumeId,$value);
	}
	public function SetMute($value=0){
		$id=@IPS_GetObjectIDByIdent(SONOS_ident_mute,$this->INSTANCE_ID);
		if($value<0)$value=$this->GetMute();
		else $ok=parent::SetMute($value);
		SetValue($id,!$value);
	}
	public function SetGroupMute($value){
		if($value<0)$value=$this->GetGroupMute();
		else $ok=parent::SetGroupMute($value);
		SetValue(VAR_ZoneMuteId,!$value);
	}
	public function SetCrossfadeMode($value){
		$id=@IPS_GetObjectIDByIdent(SONOS_ident_crossfade,$this->INSTANCE_ID);
		if($value<0)$value=$this->GetCrossfadeMode();
		else $ok=parent::SetCrossfadeMode($value);
		SetValue($id,$value);
	}
	public function SetLEDState($value) {
		$id=@IPS_GetObjectIDByIdent(SONOS_ident_ledstate,$this->INSTANCE_ID);
		if($value<0)$value=$this->GetLEDState();
		else $ok=parent::SetLEDState($value);
		SetValue($id,$value);
	}
	public function SetPlayMode($repeat=false,$shuffle=false) {
		$repeatId=@IPS_GetObjectIDByIdent(SONOS_ident_repeat,$this->INSTANCE_ID);
		$shuffleId=@IPS_GetObjectIDByIdent(SONOS_ident_shuffle,$this->INSTANCE_ID);
		if($repeat<0){
			$v=$this->GetPlayMode();
		}else{
			if($repeat&&$shuffle)$mode='SHUFFLE';
			else if($repeat)$mode='REPEAT_ALL';
			else if($shuffle)$mode='SHUFFLE_NOREPEAT';
			else $mode='NORMAL';
			$ok=parent::SetPlayMode($mode);
			$v['repeat']=$repeat;
			$v['shuffle']=$shuffle;
		}
		SetValue($repeatId,(bool)$v['repeat']);
		SetValue($shuffleId,(bool)$v['shuffle']);
	}

	
	public function RegisterEvents(){
		$callbackUrl=GetValue(VAR_CallbackUrlId);
		$SID_Id=IPS_GetObjectIdByIdent('SID',$this->INSTANCE_ID);
		if(!$callbackUrl){
			Debug ("Kein Callback Host Konfiguriert\nDer Eintrag lautet: http://ip-deines-ipsymcon-servers:".IPS_GetProperty(VAR_ServerInstanceId,'Port')."\n !ACHTUNG!!!  Gleich vorab .... localhost geht nicht *g* da deine Media-Gerte damit nichts anfangen knnen");
			return false;
		}
		if(strpos($callbackUrl,'http')===false)$callbackUrl='http://'.$callbackUrl;
		$SIDS=unserialize(GetValue($SID_Id));
		if(is_array($SIDS)&&(count($SIDS)>0)){
			echo "Events bereits Registriert";
			return true;
		}
		$callbackTime=GetValue(VAR_CallbackTimeId);
		if((!$callbackTime)||($callbackTime<60))$callbackTime=300;
		include_once ('sonos.ips.splitter.class.php');
		$SIDS=[];
		foreach(array('AVTransport','GroupRenderingControl') as $service){
			$r=$this->CallService($service,'RegisterEventCallback',array($callbackUrl,$callbackTime));
			if($r && IsSet($r['SID'])){
				$SID=trim($r['SID']);
				$SIDS[$service]=$SID;
			}
		}
		SetValue($SID_Id ,serialize($SIDS));
		if(count($SIDS)>0){
			include_once ('sonos.ips.splitter.class.php');
			$splitter=new IPSSonosSplitterInstance(VAR_SplitterInstanceId);
			foreach($SIDS as $s_id)$splitter->AddClient($this->INSTANCE_ID,$s_id);	
		}
	}

	public function UnRegisterEvents(){
		$SID_Id=IPS_GetObjectIdByIdent('SID',$this->INSTANCE_ID);
		$SIDS=unserialize(GetValue($SID_Id));
		if($SIDS){
			foreach($SIDS as $serviveName=>$SID){
				if($SID){
					try {
						$SIDS[$serviveName]='';
						$this->CallService($serviveName,'UnRegisterEventCallback',array($SID));
					} catch (Exception $e) {}
				}
			}
		} 
		$NEWSIDS=[];if($SIDS)foreach($SIDS as $k=>$v)if($v)$NEWSIDS[$k]=$v;
		if(count($NEWSIDS)>0){
			SetValue($SID_Id ,serialize($NEWSIDS));
			return false;
		}else {
			include_once ('sonos.ips.splitter.class.php');
			IPSSonos_SplitterRemoveClient($this->INSTANCE_ID);
			SetValue($SID_Id ,'');
		}
		return true;
	}

	protected function deviceCmdRaw($url, $ip='', $port=0) {
		if(!$ip)$ip=$this->_IP;
		if(!$port)$port=$this->_PORT;
		$url = "http://{$ip}:{$port}{$url}";
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		$data = curl_exec($ch);
		curl_close($ch);
		return $data;
	}
}	
	
?>
