<?
include_once('sonos.ips.config.php');
include_once('sonos.ips.variables.php');

if(!function_exists('Debug')){function Debug($data){if($_IPS['SENDER']=='Execute')echo $data.PHP_EOL;else IPS_LogMessage('SONOS_LOG:',$data);}}
class UpnpEventParser {
	private $VAL=null;
	private $IDX=null;
	private $encodeIn='UTF-8';
	private $encodeOut='ISO-8859-1';
	protected $SID='';
	protected $NAMEDVALS=null;
	protected $DebugFilePath='';

	public function SetEncoding($encodeIn, $encodeOut){
		$this->encodeIn=$encodeIn;
		$this->encodeOut=$encodeOut;
	}
	public function SetDebugLocation($location=''){
		$this->DebugFilePath=$location;
	}
	public function Check($content, $callback=null){
		$xml='';
		$this->NAMEDVALS=[];
		if(!$this->SID=$this->_CheckEventFinishd($content,$xml))return false;
		if($this->DebugFilePath){
			$date=date('Hms');
			file_put_contents($this->DebugFilePath.$date.'_event.txt',html_entity_decode(htmlspecialchars_decode($content)));
		}
		$PARSER=xml_parser_create($this->encodeIn);
		xml_parser_set_option($PARSER, XML_OPTION_TARGET_ENCODING,$this->encodeOut);
		xml_parse_into_struct($PARSER, html_entity_decode(htmlspecialchars_decode($xml)), $this->VAL, $this->IDX);
		xml_parser_free($PARSER);
		foreach($this->IDX as $id=>$i){
			if(isSet($this->VAL[$i[0]]['attributes'])&&isSet($this->VAL[$i[0]]['attributes']['VAL'])){
				$v=$this->VAL[$i[0]]['attributes']['VAL'];
				if(is_float($v))$v=(float)$v;
				elseif(is_numeric($v))$v=(int)$v;
				elseif(is_string($v)){
					if($v=='true'||$v=='ja'||$v=='yes'||$v=='on')$v=true;
					elseif($v=='false'||$v=='nein'||$v=='no'||$v=='off')$v=false;
				}
				$this->NAMEDVALS[$id]=$v;
			}
		}
		if($callback){
			$callback($this->SID,$this->NAMEDVALS);
		};
		return true;
	}	
	function GetValue($name, $typ='attributes',$sub='VAL'){
		if(!isSet($this->IDX[$name]))return false;
		$ip=&$this->VAL[$this->IDX[$name][0]];
		if(!$typ)return $ip;
		if(!isSet($ip[$typ]))return false;
		$vp=&$ip[$typ];
		if(!$sub)return $vp;
		if(!isSet($vp[$sub]))return false;
		return $vp[$sub];
	}
	function GetNamedValues(){
		return $this->NAMEDVALS;
	}
	function & GetValues(){
		return $this->VAL;
	}
	function & GetIndex(){
		return $this->IDX;
	}
	private function _CheckEventFinishd($data, &$content){
		$ContentLength=-1;$SID='';
		$inHead=true; $content='';
		foreach(explode("\n",$data) as $line){
			if($inHead){
				$line=trim($line);
				if(!$line){ $inHead=false; continue; }
				if($ContentLength==-1||!$SID){
					$m=explode(':',$line);
					$m[0]=trim(strtoupper($m[0]));
					if($m[0]=='CONTENT-LENGTH'){
						$ContentLength=(int)$m[1];		
					}elseif($m[0]=='SID'){
						array_shift($m);
						$SID=trim(implode(':',$m));
					}
				}
			}else $content.=$line;
		}
		return (($ContentLength!=-1)&& (strlen($content)>=$ContentLength))?$SID:false;
	}

	private function http_parse_headers($raw_header) {
        $headers = array();
        $key = ''; $inHead=(strpos($raw_headers,'HTTP/')!==false);
        foreach(explode("\n", $raw_headers) as $i => $h){
			if($inHead){
				if(!trim($h)){$inHead=false;continue;};
				$h = explode(':', $h, 2);
				if (isset($h[1])){
					$h[0]=strtoupper($h[0]);
					if (!isset($headers[$h[0]]))
						$headers[$h[0]] = trim($h[1]);
					elseif (is_array($headers[$h[0]])){
						 $headers[$h[0]] = array_merge($headers[$h[0]], array(trim($h[1]))); 
					}else{
						$headers[$h[0]] = array_merge(array($headers[$h[0]]), array(trim($h[1]))); 
					}
					$key = $h[0]; 
				}else if (!$key) 
                    $headers['PRE'] = trim($h[0]); 
			}else { 
				if(!isSet($headers['CONTENT']))$headers['CONTENT']=trim($h);
				else $headers['CONTENT'].= "\n".trim($h); 
            } 
        }
		if((count($headers)>1)&&isSet($headers['CONTENT-LENGTH'])){
			$len=(int)$headers['CONTENT-LENGTH'];
			if($len==0)$headers['COMPLED']=1;
			elseif(isSet($headers['CONTENT'])&&(strlen($headers['CONTENT']) >= $len))$headers['COMPLED']=1;
			else $headers['COMPLED']=0;	
		}else $headers['COMPLED']=1;
		return $headers;
    }
	
}


class IPSSonosSplitterInstance extends UpnpEventParser {
	private $INSTANCE_ID=0;
	private $CLIENTS_ID=0;
	private $AUTOCREATE=false; // Neue Devices und Variablen Anlegen
	private $CLIENTS=[];
	
	public function __construct($InstanzID){
		$this->InstanzID=$InstanzID;
		$this->CLIENTS_ID=IPS_GetObjectIdByIdent('CLIENTS',$this->InstanzID);
		if(!$this->CLIENTS_ID){
			$this->CLIENTS_ID=$this->_CreateVariable('CLIENTS',3,$this->InstanzID);
			$this->_CreateVariable('AUTOCREATE',0,$this->InstanzID,true,'Neue Variable autom. erstellen');
			$this->_CreateVariable('DEBUG_PATH',3,$this->InstanzID,'','Ausgabe Pfad fr Event Logs');
			$this->AUTOCREATE=true;
			$this->CLIENTS=[];
			SetValue($this->CLIENTS_ID,serialize($this->CLIENTS));
		}else {
			if(!$this->CLIENTS=unserialize(GetValue($this->CLIENTS_ID)))$this->CLIENTS=[];
			$this->AUTOCREATE=GetValue(IPS_GetObjectIdByIdent('AUTOCREATE',$this->InstanzID));
			$this->DebugFilePath=GetValue(IPS_GetObjectIdByIdent('DEBUG_PATH',$this->InstanzID));
		}
	}
	public function HandleEvent($eventData){
		$compled=$this->Check($eventData);
		if($compled){
			if(isSet($this->CLIENTS[$this->SID])){
				$DeviceId=$this->CLIENTS[$this->SID];
			}else {
				Debug("SplitterInstance => HandleEvent => Ubekannte SID : {$this->SID}");
				return false;	
			}
			foreach($this->NAMEDVALS as $VarIdent=>$Value){
				$VarValue=IPSSonos_VarValue( $VarIdent, $Value);
				if(is_array($VarValue)){
					foreach($VarValue as $SubIdent=>$SubValue){
						if(IPSSonos_VarIsHidden($SubIdent)===true)continue;
						if(!IPSSonos_VarDefined($SubIdent)&&(!$this->AUTOCREATE))continue;
						$SubName=IPSSonos_VarName($SubIdent);
						$SubType=IPSSonos_VarType($SubIdent);
						$this->_CreateVariable($SubIdent, $SubType, $DeviceId ,$SubValue, $SubName );
					}
				}else{
					if(IPSSonos_VarIsHidden($VarIdent)===true)continue;
					if(!IPSSonos_VarDefined($VarIdent)&&(!$this->AUTOCREATE))continue;
					$VarType=IPSSonos_VarType($VarIdent);	
					$VarName=IPSSonos_VarName( $VarIdent);
					$this->_CreateVariable($VarIdent,$VarType, $DeviceId,$VarValue, $VarName );
				}
			}
		}
		return $compled;
	}
	public function AddClient($PlayerInstanceID, $SID){
		$this->CLIENTS[$SID]=$PlayerInstanceID;
		SetValue($this->CLIENTS_ID,serialize($this->CLIENTS));
	}
	public function RemoveClient($PlayerInstanceID, $SID=''){
		$clients=[];
		foreach($this->CLIENTS as $v=>$i){
			if($i!=$PlayerInstanceID)$clients[$v]=$i;
		}
		$this->CLIENTS=$clients;
		SetValue($this->CLIENTS_ID,serialize($this->CLIENTS));
	}
	private function _CreateDevice($SID){
		$deviceCatId=VAR_PlayerCategoryId;
		preg_match('/RINCON_(.+)_/',$SID,$matches);
		$ident=(isSet($matches[1]))?$matches[1]:$SID;
		
		return $this->_CreateInstance($ident, $deviceCatId);
	}
	private function _CreateVariable ($Ident, $Type,  $ParentId, $Value=null, $Name='') {
		$VariableId = @IPS_GetObjectIDByIdent($Ident, $ParentId);
		if ($VariableId === false) {
			if($Type<0){
				if(is_null($Value)){
					$Type=3;
				}else{
					switch(gettype($Value)){
						case 'boolean': $Type=0;break;
						case 'integer': $Type=1;break;
						case 'float'  : $Type=2;break;
						default       : $Type=3;break;
					}
				}
			}
			$VariableId = IPS_CreateVariable($Type);
			IPS_SetParent($VariableId,$ParentId);
			IPS_SetName($VariableId, (($Name)?$Name:$Ident));
			IPS_SetIdent($VariableId, $Ident);
		}
//Debug("_CreateVar : $Ident ($VariableId)=$Value");				
		if(!is_null($Value)){
			$oldValue=GetValue($VariableId);
			SetValue($VariableId, $Value); 
//Debug("Set Var : $Ident ($VariableId )= Old => $oldValue | New => $Value");				
		}
		return $VariableId;
	}
	private function _CreateInstance($Name, $ParentId, $Position=false) {
		$InstanceId = @IPS_GetObjectIDByIdent(Get_IdentByName($Name), $ParentId);
		if ($InstanceId === false) $InstanceId = @IPS_GetCategoryIDByName($Name, $ParentId);
		if ($InstanceId === false) {
			$InstanceId	= IPS_CreateInstance("{485D0419-BE97-4548-AA9C-C083EB82E61E}");
			IPS_SetParent($InstanceId, $ParentId);
			IPS_SetName($InstanceId, $Name);
			IPS_SetIdent($InstanceId, $Name);
			if ($Position!==false)IPS_SetPosition($InstanceId, $Position);
			$this->_CreateVariable('SID',3,$InstanceId);
			$this->_CreateVariable('HOST',3,$InstanceId);
			//IPS_SetIcon($CategoryId, $Icon);
//			Debug ('Created Category '.$Name.'='.$CategoryId."");
		}
		return $InstanceId;
	}
}

function IPSSonos_SplitterAddClient($DeviceID, $SID){
	if(!defined('VAR_SplitterInstanceId')){
		Debug ('IPSSonos_SplitterAddClient:: Keine SplitterInstanceId in sonoa.ips.config.php definiert!!!! Lsung:ReInstall');
		return false;
	}
	return (new IPSSonosSplitterInstance(VAR_SplitterInstanceId))->AddClient($DeviceID,$SID);
}
function IPSSonos_SplitterRemoveClient($DeviceID){
	if(!defined('VAR_SplitterInstanceId')){
		Debug ('IPSSonos_SplitterRemoveClient:: Keine SplitterInstanceId in sonoa.ips.config.php definiert!!!! Lsung:ReInstall');
		return false;
	}
	return (new IPSSonosSplitterInstance(VAR_SplitterInstanceId))->RemoveClient($DeviceID);
}

?>