<?
require_once('sonos.ips.defines.php');
define('opStatic',1);
define('opHidden',2);
define('opShowInZone',4);
define('opShowInOpt',8);
define('opShowInPlayer',16);
define('opShowInZonePlayer',32);

$SonosVarProfiles[SONOS_ident_repeat]=array('NAME'=>SONOS_name_repeat, 'TYP'=>0,'OPTS'=>opStatic+opShowInOpt,'PROFIL'=>'~Switch');
$SonosVarProfiles[SONOS_ident_shuffle]=array('NAME'=>SONOS_name_shuffle, 'TYP'=>0,'OPTS'=>opStatic+opShowInOpt,'PROFIL'=>'~Switch');
$SonosVarProfiles[SONOS_ident_track]=array('NAME'=>SONOS_name_track,'TYP'=>1,'OPTS'=>opStatic+opShowInZonePlayer);
$SonosVarProfiles[SONOS_ident_duration]=array('NAME'=>SONOS_name_duration,'TYP'=>3,'OPTS'=>opStatic+opShowInZonePlayer);
$SonosVarProfiles[SONOS_ident_tracknums]=array('NAME'=>SONOS_name_tracknums,'TYP'=>1,'OPTS'=>opStatic+opShowInZonePlayer);
$SonosVarProfiles['INSTANCEID']=array('HIDDEN'=>1);
//$SonosVarProfiles['CURRENTTRACKURI']=array('NAME'=>'Wiedergabe URL','TYP'=>3,'OPTS'=>opStatic);
$SonosVarProfiles[SONOS_ident_crossfade]=array('NAME'=>SONOS_name_crossfade,'TYP'=>0,'OPTS'=>opStatic+opShowInOpt,'PROFIL'=>'~Switch');
$SonosVarProfiles[SONOS_ident_vol]=array('NAME'=>SONOS_name_vol,'TYP'=>1,'OPTS'=>opStatic+opShowInPlayer,'PROFIL'=>'~Intensity.100');
$SonosVarProfiles[SONOS_ident_ledstate]=array('NAME'=>SONOS_name_ledstate,'TYP'=>0,'OPTS'=>0,'PROFIL'=>'~Switch');
$SonosVarProfiles[SONOS_ident_mute]=array('NAME'=>SONOS_name_mute,'TYP'=>0,'OPTS'=>opShowInPlayer,'PROFIL'=>'~Switch');
//$SonosVarProfiles[SONOS_ident_zvol]=array('NAME'=>SONOS_name_zvol,'TYP'=>1,'OPTS'=>opStatic+opShowInZone,'PROFIL'=>'~Intensity.100');
//$SonosVarProfiles[SONOS_ident_zmute]=array('NAME'=>SONOS_name_zmute,'TYP'=>0,'OPTS'=>opShowInZoneOpt,'PROFIL'=>'~Switch');


$SonosVarProfiles[SONOS_ident_state]=array(
	'NAME'=>SONOS_name_state,
	'TYP'=>1,
	'OPTS'=>opStatic+opShowInZone,
	'PROFIL'=>'SONOS_STATE',
	'set'=>function($v){
		$a=array("STOPPED"=>SONOS_state_stop,'PLAYING'=>SONOS_state_play,'PAUSED_PLAYBACK'=>SONOS_state_pause,'TRANSITIONING'=>SONOS_state_stop,'default'=>SONOS_state_stop);
		return (isSet($a[$v]))?$a[$v]:$a['default'];
	},
	'get'=>function($v){
		$a=array(SONOS_state_stop=>'STOPPED',SONOS_state_play=>'PLAYING',SONOS_state_pause=>'PAUSED_PLAYBACK');
		return (int)(isSet($a[$v]))?$a[$v]:'STOPPED';
});

$SonosVarProfiles['CURRENTPLAYMODE']=array(
	'NAME'=>'Wiedergabe Modus',
	'OPS'=>opHidden,
	'TYP'=>3,
	'set'=>function($v){
		$a=array("NORMAL"=>array(SONOS_ident_repeat=>0,SONOS_ident_shuffle=>0),
				'REPEAT_ALL'=>array(SONOS_ident_repeat=>1,SONOS_ident_shuffle=>0),
				'SHUFFLE_NOREPEAT'=>array(SONOS_ident_repeat=>0,SONOS_ident_shuffle=>1),
				'SHUFFLE'=>array(SONOS_ident_repeat=>1,SONOS_ident_shuffle=>1),
				'default'=>array(SONOS_ident_repeat=>0,SONOS_ident_shuffle=>0));
		return (isSet($a[$v]))?$a[$v]:$a['default'];
	},
	'get'=>function($array){
		if($array[0])return ($array[1])?'REPEAT_ALL':'SHUFFLE_NOREPEAT';
		else return ($array[1])?'SHUFFLE':'NORMAL';
});

function IPSSonos_VarDefined($varIdent){
global $SonosVarProfiles;
	return isSet($SonosVarProfiles[$varIdent]);
}
function IPSSonos_VarValue($varIdent, $value,$mode=0){
global $SonosVarProfiles;
	if(isSet($SonosVarProfiles[$varIdent])){
		$mode=($mode)?'get':'set';
		return (isSet($SonosVarProfiles[$varIdent][$mode]))?$SonosVarProfiles[$varIdent][$mode]($value):$value;
	}
	return $value;
}
function IPSSonos_VarName($varIdent){
global $SonosVarProfiles;
	if(isSet($SonosVarProfiles[$varIdent])){
		return (isSet($SonosVarProfiles[$varIdent]['NAME']))?$SonosVarProfiles[$varIdent]['NAME']:$varIdent;
	}
	return $varIdent;
}
function IPSSonos_VarType($varIdent){
global $SonosVarProfiles;
	if(isSet($SonosVarProfiles[$varIdent])){
		return (isSet($SonosVarProfiles[$varIdent]['TYP']))?$SonosVarProfiles[$varIdent]['TYP']:-1;
	}
	return -1;
}
function IPSSonos_VarProfil($varIdent){
global $SonosVarProfiles;
	if(isSet($SonosVarProfiles[$varIdent])){
		return (isSet($SonosVarProfiles[$varIdent]['PROFIL']))?$SonosVarProfiles[$varIdent]['PROFIL']:'';
	}
	return '';
}
function IPSSonos_VarIsHidden($varIdent){
global $SonosVarProfiles;
	if(isSet($SonosVarProfiles[$varIdent])){
		return (isSet($SonosVarProfiles[$varIdent]['HIDDEN']))?true:false;
	}
	return false;
}

function IPSSonos_VarInfo($varIdent){
global $SonosVarProfiles;
	return (isSet($SonosVarProfiles[$varIdent]))?$SonosVarProfiles[$varIdent]:null;
}


?>
